FUNCTION chebev( a, b, c, m, x, ier )

   implicit none
   REAL(kind=8) :: chebev
   INTEGER, intent(in) :: m
   INTEGER, intent(out) :: ier
   REAL(kind=8), intent(in) :: a, b, x, c(m)
   INTEGER :: j
   REAL(kind=8) :: d, dd, sv, y, y2

   ier = 0
   if ( (x-a)*(x-b) > 0.0_8 ) then     ! x not in range in chebev
      ier = 1
      chebev = 0.0_8
      return
   endif
   d = 0.0_8
   dd = 0.0_8
   y = (2.0_8*x-a-b)/(b-a)
   y2 = 2.0_8*y
   do j = m, 2, -1
     sv = d
     d = y2*d-dd+c(j)
     dd = sv
   end do
   chebev = y*d-dd+0.5_8*c(1)

END FUNCTION chebev
