function expdv1( idum )

!-----------------------------------------------------------------------
!
!     Returns a random variable distributed according to an exponential
!     distribution with parameter one.
!
!     idum  - Input . A negative integer to initialize the    - Integer
!             Output. random sequence. Thereafter do not
!                     alter this argument between successive
!                     deviates in a sequence
!
!     External functions called:
!        RAN1
!     Fortran  functions called:
!        LOG
!
!-----------------------------------------------------------------------

   implicit none

!     Function
!     --------

   real :: expdv1

!     Arguments
!     ---------

   integer, intent(inout) :: idum

!     Local declarations
!     ------------------

   real, external :: ran1
   real, parameter :: zero=0.0
   real :: dum

   !-----------------------------------------------------------------

   do
     dum = ran1(idum)
     if ( dum > zero ) exit
   end do
   expdv1 = -log(dum)

end function expdv1
