function expdv2( idum )

!-----------------------------------------------------------------------
!
!     Returns a random variable distributed according to an exponential
!     distribution with parameter one. (Real*8 version)
!
!     idum  - Input . A negative integer to initialize the    - Integer
!             Output. random sequence. Thereafter do not
!                     alter this argument between successive
!                     deviates in a sequence
!
!     External functions called:
!        RAN12
!     Fortran  functions called:
!        LOG
!
!-----------------------------------------------------------------------

   implicit none

!     Function
!     --------

   real(kind=8) :: expdv2

!     Arguments
!     ---------

   integer, intent(inout) :: idum

!     Local declarations
!     ------------------

   real(kind=8), external :: ran12
   real(kind=8), parameter :: zero=0.0_8
   real(kind=8) :: dum

   !-----------------------------------------------------------------

   do
     dum = ran1(idum)
     if ( dum > zero ) exit
   end do
   expdv2 = -log(dum)

end function expdv2
